import java.io.File                                 // import java.io.File
import scala.collection.mutable.HashMap             // import scala.collection.mutable.HashMap

object todaysLecture {
  def fac(n: Int) = {
    var res   = 1
    var count = n
    while (count > 0) {
      res   *= count
      count -= 1
    }
    res
  }

def minc(x:Int) = x + 1

/* let inc x = x + 1 */

def inc(x:Int) = {
  x + 1
}

/* let inc = fun x -> x + 1 */
val inc = (x:Int) => x + 1

object incO {
  val a = 10
  val b = 20
  def apply(x: Int) = x + 1
  def sidekick(y:Int) = "hahah!"
}

def fact(n:Int):Int = if (n > 0) { n * fact(n-1) } else 1

def fac(n: Int): Int =
  n match {
    case n if (n > 0) => n * fac(n-1)
    case _            => 1
  }

/*
let rec fac n =
  match n with
    | n when (n > 0) -> n * fac(n-1)
    | _              -> 1
    */



def adder(x: Int, y: Int): Int = {
  println("thou calleth adder with (x=%d, y=%d)".format(x, y))
  val z = x + y
  println("thou getteth (z=%d)".format(z))
  z
}

def fac(n: Int):Int = {
  if (n > 0) {
    n * fac (n-1)
  }
  else
    1
}

/*
def fac(n: Int): Int =
    n match {
      case n if (n > 0) => n * fac(n-1)
      case _            => 1
    }
*/

/*
  let rec fac n =
    match n with
      | _ when (n > 0) -> n * fac (n - 1)
      | _              -> 1
   */

}







object Freq {

  def fileContents(file: String): List[String] = {
    val f = new java.io.File(file)
    try {
      scala.io.Source.fromFile(f).getLines().toList
    } catch {
      case e: java.io.FileNotFoundException => {
        println("WTF! No such file exists")
        List()
      }
    }
  }

  def fileContentz(file: String): Iterator[String] = {
    val f = new java.io.File(file)
    try {
      scala.io.Source.fromFile(f).getLines()
    } catch {
      case e: java.io.FileNotFoundException => {
        println("WTF! No such file exists")
        Iterator()
      }
    }
  }

  def fileCharz(file: String): Iterator[Char] = {
    for (line <- fileContentz(file); char <- line) yield char
  }

  def fileChars(file: String): List[Char] = {
    for (line <- fileContents(file); char <- line) yield char
  }

  def freq[A](xs: Iterable[A]): HashMap[A, Int] = {
    val freqMap = new HashMap[A, Int]
    for (x <- xs) {
      freqMap(x) = 1 + freqMap.getOrElse(x, 0)
    }
    freqMap
  }

  def apply[A](xs: Iterable[A]) = freq(xs)

  def   show[A](m: HashMap[A, Int], size: Int) = {
    for ((k, v) <- m) { println(k + " : " + "#" * (v / size)) }
  }

  def main(args: Array[String]) {
    val str   = fileChars(args(0))
    val freqs = freq(str)
    show(freqs, 1)
  }

}                                                   // defined object Freq




/*
import scala.collection.immutable.Map

var immutMap : Map[String, Int] = Map()
   immutMap   =======> { }

var other = immutMap
   immutMap   =======> { }
   other      =======>

immutMap = immutMap + ("mon" -> 1)

   immutMap   =========>    { "mon" -> 1}
   other      =========>    { }

immutMap = immutMap + ("mon" -> 2)

   immutMap   :=========>   { "mon" -> 2}
   other      :=========>   { }

val res = other("mon")
  "NOT FOUND" exN

var mutMap : HashMap[String, Int] = HashMap()

  mutMap :======>   { }*

var other = mutMap

  mutMap :==========> { }*
  other  :==========>

mutMap    += "mon" -> 1

  mutMap :==========> { "mon" -> 1 }*
  other  :==========>

mutMap    + = "mon" -> 2

  mutMap :==========> { "mon" -> 2 }*
  other  :==========>

val res   = other("mon")

  2

for (x <- coll) { doStuff }

coll.foreach(x => doStuff)


for (x <- coll if cond) { doStuff }

coll
  .filter(x => cond)
  .foreach (x => doStuff)



  for (f <- dir.listFiles
              if f.getName.endsWith(".markdown")) { println(f) }

val words = Array("you", "are", "doing")

def wordUpper(w:String) = w.map(_.toUpper)

words.map(wordUpper)

Array("YOU", "ARE", "DOING")

for   (w <- words) yield wordUpper(w)

for (x <- coll) yield thing

coll.map(x => thing)

val scalaFiles = for (f <- dir.listFiles
                      if f.getName.endsWith(".scala"))
                 yield f

dir.listFiles
   .filter(f => f.getName.endsWith(".scala"))
   .map(f => f)

val ll = List( List(1, 2)
             , List(3, 4)
             )

val res = for (xs <- ll;
               x  <- xs)
          yield x

          

   xs ==> List(1, 2)
     x ==> 1           // yield 1
     x ==> 2           // yield 2

   xs ==> List(3, 4)
     x ==> 3           // yield 3
     x ==> 3           // yield 4

  List(1, 2, 3, 4)

for ( x <- ll(0)
    ; y <- ll(1))
yield (x, y)

val ll = List( List(1, 2)
             , List(3, 4)
             )
x ====> 1
  y ====> 3    // yield (1, 3)
  y ====> 4    // yield (1, 4)

x ====> 2
  y ====> 3    // yield (2, 3)
  y ====> 4    // yield (2, 4)

List(...)


*/
